#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire400three4xi.py">
#<abstract4xi abstract = "fires to direction three and to distance 400"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire400three4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2three4004xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - ) - STUBS ONLY - ALL ARE IN FILES
# -------------------------------------------------------------------------------------------------    

shot2three4004xi = {
                1:'0x11y-399z',
                2:'0x388y-96z',
                3:'0x3y-399z',
                4:'0x7y-399z',
                5:'0x94y-388z',
                6:'101x379y-76z',
                7:'101x381y-306z',
                8:'106x107y-370z',
                9:'107x352y-156z',
                10:'10x101y-386z',
                11:'112x327y-200z',
                12:'114x104y-368z',
                13:'114x299y-238z',
                14:'121x374y-72z',
                15:'122x100y-367z',
                16:'126x347y-152z',
                17:'12x33y-398z',
                18:'12x359y-174z',
                19:'130x322y-196z',
                20:'130x96y-365z',
                21:'131x295y-235z',
                22:'138x91y-363z',
                23:'13x12y-399z',
                24:'141x367y-68z',
                25:'145x341y-148z',
                26:'147x290y-232z',
                27:'147x317y-193z',
                28:'15x104y-385z',
                29:'15x36y-398z',
                30:'160x360y-64z',
                31:'163x284y-229z',
                32:'163x335y-145z',
                33:'165x310y-189z',
                34:'16x14y-399z',
                35:'179x277y-225z',
                36:'179x352y-60z',
                37:'181x327y-141z',
                38:'182x303y-186z',
                39:'18x39y-397z',
                40:'194x269y-222z',
                41:'197x342y-56z',
                42:'198x295y-182z',
                43:'199x318y-137z',
                44:'1x15y-399z',
                45:'1x1y-399z',
                46:'20x16y-399z',
                47:'20x388y-92z',
                48:'210x260y-219z',
                49:'215x285y-179z',
                50:'215x332y-52z',
                51:'216x308y-133z',
                52:'224x250y-215z',
                53:'22x107y-384z',
                54:'22x41y-397z',
                55:'230x275y-175z',
                56:'232x298y-130z',
                57:'233x321y-48z',
                58:'239x240y-212z',
                59:'23x334y-217z',
                60:'246x264y-172z',
                61:'249x286y-126z',
                62:'24x17y-398z',
                63:'250x308y-45z',
                64:'253x228y-208z',
                65:'260x252y-168z',
                66:'264x273y-122z',
                67:'266x216y-205z',
                68:'266x295y-41z',
                69:'274x239y-164z',
                70:'278x203y-202z',
                71:'279x260y-118z',
                72:'27x44y-396z',
                73:'281x281y-37z',
                74:'288x225y-161z',
                75:'28x109y-383z',
                76:'293x246y-114z',
                77:'296x266y-33z',
                78:'2x19y-399z',
                79:'301x211y-157z',
                80:'306x231y-110z',
                81:'310x251y-29z',
                82:'319x215y-107z',
                83:'31x360y-170z',
                84:'31x45y-396z',
                85:'322x234y-25z',
                86:'34x0y-398z',
                87:'35x111y-382z',
                88:'36x47y-395z',
                89:'3x5y-399z',
                90:'40x387y-88z',
                91:'41x335y-214z',
                92:'41x48y-394z',
                93:'42x113y-381z',
                94:'46x48y-394z',
                95:'4x23y-399z',
                96:'4x98y-387z',
                97:'50x114y-379z',
                98:'50x359y-167z',
                99:'52x49y-393z',
                100:'57x115y-378z',
                101:'57x48y-392z',
                102:'58x334y-210z',
                103:'5x333y-220z',
                104:'61x386y-84z',
                105:'63x48y-392z',
                106:'65x115y-377z',
                107:'68x46y-391z',
                108:'69x358y-163z',
                109:'6x27y-399z',
                110:'6x8y-399z',
                111:'73x114y-376z',
                112:'76x333y-207z',
                113:'81x113y-374z',
                114:'81x383y-80z',
                115:'88x355y-159z',
                116:'89x112y-373z',
                117:'94x330y-203z',
                118:'97x303y-241z',
                119:'98x110y-371z',
                120:'9x10y-399z',
                121:'9x30y-398z'}
                
 
# -----------------------------------------------------------------------------------------------------------
#<function4xi function = "fire400three4xi" usage = "target function for chargethree4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -----------------------------------------------------------------------------------------------------------
def fire400three4xi(queue2three, consumer_channel2three, publisher_channel2three):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE400THREE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE400THREE4XI -  QUEUE2THREE: ", queue2three)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE400THREE4XI -  CONSUMER_CHANNEL2THREE: ", consumer_channel2three)
        #  
              
        print("\n (STEP 1A4/33) OF FIRE400THREE4XI -  PUBLISHER_CHANNEL2THREE: ", publisher_channel2three)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE400THREE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2three.put(shot2three4004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE400THREE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE400THREE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE400THREE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4three = "<ack2put4xi>queue2three8shot2three4004xi</ack2put4xi>"
        else:
            message2send4three = "<nack2put4xi>queue2three8shot2three4004xi</nack2put4xi>" 
            
        publisher_channel2three.send(message2send4three)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE400THREE4XI -  SENT MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE400THREE4XI *** FAILED TO SEND MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE400THREE4XI - RETURNING QUEUE OBJECT QUEUE2THREE: ", queue2three, " - TIME: ", time4xi())  
        # 
            
    return queue2three    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire400three4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                               
                